/*
 *  Classified Tydeman Consulting Proprietary
 *  Copyright (C) 2005 Tydeman Consulting.  All rights reserved.
 *
 *  Fred Tydeman	tydeman@tybor.com
 *
 * - -- --- ---- ----- -------------------------------------------------
 *
 *    This code is copyrighted.  Under the copyright laws, this code may
 *         not be copied, in whole or part, without prior written
 *         consent of Tydeman Consulting.
 *
 *    RESTRICTED RIGHTS LEGEND: Use, duplication, or disclosure by the
 *         government is subject to restrictions as set forth in
 *         subparagraph (c)(1)(ii) of the Rights in Technical Data and
 *         Computer Software clause at DFARS 252.227-7013 and
 *         FAR 52.227-19.
 *
 * - -- --- ---- ----- -------------------------------------------------
 * $Revision: 2.1 $
 ***********************************************************************
 *  FILE: fenvon.h
 *
 *  Description:  Do the different forms of FENV ACCESS ON, including 
 *  compiler specific ones.  See writeup in mydefs.h just before 
 *  #include "fenvon.h" for why so many forms.
 *
 *  MODIFICATION HISTORY:
 *
 * 2005/05/08 - Create from mydefs.h and myfloat.h
 * 2005/05/08 - Update DEBUG section.
 *
 ***********************************************************************/

/*lint -efile(766,fenvon.h) // header file "not" used */

#ifdef DEBUG	/* local override of DISALLOWs to force errors to show */
  #ifdef DEBUG2	/* Kills some compilers */
  #endif
  #ifdef DEBUG3
  #endif
  #undef  DISALLOW_PRAGMAS
  #undef  DISALLOW_PRAGMA_FENV_ACCESS
#endif

#if (!defined DISALLOW_PRAGMAS) && (!defined DISALLOW_PRAGMA_FENV_ACCESS) \
 && (!defined LMS_NO_FENV_ACCESS)
  #if (19970207uL <= FPCE_TEST_LVL)
    #pragma STDC FENV_ACCESS ON
  #else
    #pragma fenv_access on
  #endif
  #ifdef FENV_ACCESS_ON		/* Want IEEE safe code generation */
	 FENV_ACCESS_ON
  #endif
  #ifdef _MSC_VER		/* Microsoft Visual Studio specific */
    #pragma fenv_access(on)
  #endif
#endif
