/*
 * Classified Tydeman Consulting Proprietary
 * Copyright (C) 1994, 2004 Tydeman Consulting.  All rights reserved.
 *
 *  Fred Tydeman	tydeman@tybor.com
 *
 * This is a subset of the <fenv.h> that should be vendor provided and
 * is enough to compile the sample fetestexcept(), feclearexecpt(),
 * feraiseexecpt(), and fegetround().  This is setup for Intel 80*87
 * FPU chip on IBM PC clone, but you are expected to modify this file
 * for your hardware (if required).
 *
 * If the compiler you are testing has its own <fenv.h>, then you
 * should leave this file alone, but you may need to make sure
 * sample.h has FENV_H defined to get the Standard C <fenv.h>, instead
 * of "fenvsamp.h".
 *
 * If <fenv.h> is missing, then edit this file to define the correct
 * hardware setup.  If you decide to use the dummy fe*except()
 * functions that do nothing (the default), then these values are good
 * enough.
 *
 * MODIFICATION HISTORY:
 *
 * 1994/07/28 - Create so can do NCEG FPCE test suite on IBM PC clone.
 * 1995/02/02 - Create a subset for public sample use.
 * 1997/01/17 - Add in rounding related items.
 * 1997/01/23 - Make default name differ from Standard C's <fenv.h>
 * 2000/03/01 - Make classification explicit in each file.
 * 2000/03/01 - Remove confidential so can post to public ftp site.
 * 2004/08/03 - Update to align with TC1 (DR 202) of C99.
 *
 ***********************************************************************/

#ifndef _FENV_H_
#define _FENV_H_ 1
	
#define FE_INEXACT	0x0020
#define FE_UNDERFLOW	0x0010
#define FE_OVERFLOW	0x0008
#define FE_DIVBYZERO	0x0004
#define FE_INVALID	0x0001
	
#define FE_ALL_EXCEPT	0x003d
	
int  fetestexcept( int __excepts );
#if (20010901uL <= FPCE_TEST_LVL)	/* C99 + TC1 */
int  feclearexcept( int __excepts );
int  feraiseexcept( int __excepts );
#else					/* just C99 */
void feclearexcept( int __excepts );
void feraiseexcept( int __excepts );
#endif

#define FE_TONEAREST	0x0000
#define FE_DOWNWARD	0x0400
#define FE_UPWARD	0x0800
#define FE_TOWARDZERO	0x0c00

int fegetround( void );

#endif /* _FENV_H_ */
