/*
 *  Classified Tydeman Consulting Proprietary
 *  Copyright (C) 1996, 2008 Tydeman Consulting.  All rights reserved.
 *
 *  Fred Tydeman		tydeman@tybor.com
 *
 * - -- --- ---- ----- -------------------------------------------------
 *
 *    This code is copyrighted.  Under the copyright laws, this code may
 *         not be copied, in whole or part, without prior written
 *         consent of Tydeman Consulting.
 *
 *    RESTRICTED RIGHTS LEGEND: Use, duplication, or disclosure by the
 *         government is subject to restrictions as set forth in
 *         subparagraph (c)(1)(ii) of the Rights in Technical Data and
 *         Computer Software clause at DFARS 252.227-7013 and
 *         FAR 52.227-19.
 *
 * - -- --- ---- ----- -------------------------------------------------
 * $Revision: 1.1 $
 ***********************************************************************
 *  FILE: v1150001.h	which is included by g1150000.h
 *
 *  Test vectors for sin == sine == for any type, any precision.
 *
 *  MODIFICATION HISTORY:
 *
 * 1996/06/17 - Create via split into IEEE and general.
 * 1997/01/14 - Add FPK() macro usage.
 * 1997/01/26 - *_t -> *_q (reserved by POSIX.1).
 * 1997/09/17 - Update email address.
 * 1997/10/03 - Add IMPL_INEXACT_*.
 * 1998/04/06 - Change required inexact into IMPL_INEXACT_* for MIN.
 * 1999/05/18 - Add tests at "large" powers of 2.
 * 1999/05/26 - Add tests at "large" multiples of pi.
 * 2000/03/01 - Make classification explicit in each file.
 * 2000/03/01 - Remove confidential so can post to public ftp site. 
 * 2004/07/18 - Add FIX_CONST_EXP_IN_INIT.
 * 2006/03/28 - Add FP_EXP().
 * 2006/04/10 - Redo vector 1 to avoid underflow (+move to v1150000).
 * 2006/04/14 - Indent #if's.
 * 2006/04/14 - Update DEBUG section.
 * 2008/02/12 - Add DFP items.
 * 2008/07/14 - Shorten marco symbols to less than 32 chars.
 *
 ***********************************************************************/
#ifdef DEBUG	/* local override of FIXes to force errors to show */
  #ifdef DEBUG2	/* Kills some compilers */
    #undef  FIX_CONST_EXP_IN_INIT
  #endif
#endif
#ifdef DEBUG	/* local override of FIXes to force errors to show */
  #ifdef DEBUG3
  #endif
#endif

#ifndef FIX_CONST_EXP_IN_INIT
  #define FP_EXP(x) (x)
#else
  #define FP_EXP(x) ZERO_q
  #define LMS_NEED_FIXES_3_28
#endif

#undef  TESTING_IEEE_VECTORS

/*  0*/{+ZERO_q             ,+ZERO_q             ,  BIT4BIT,                0, 0 },
/*  1*/{ FP_EXP(MIN_q+MIN_q), FP_EXP(MIN_q+MIN_q),  ULP_f  , IMPL_INEXACT_sin, FE_INEXACT },
/*  2*/{ ULP_q              , ULP_q              ,  ULP_f  , IMPL_INEXACT_sin, FE_INEXACT },

#if 2 == FP_RADIX
/*
 * Check 1 / 2**n for n = 30 to 5
 */
/*  3*/{FP_EXP(ONE_q/FPK(1073741824.)), FPK(9.313225746154785154903677388422806518822e-10), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*  4*/{FP_EXP(ONE_q/FPK( 536870912.)), FPK(1.862645149230957030172941910738245215198e-9), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*  5*/{FP_EXP(ONE_q/FPK( 268435456.)), FPK(3.725290298461914053883535285905961726068e-9), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*  6*/{FP_EXP(ONE_q/FPK( 134217728.)), FPK(7.450580596923828056068282287247693952039e-9), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*  7*/{FP_EXP(ONE_q/FPK(  67108864.)), FPK(1.490116119384765569854625829798155620809e-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*  8*/{FP_EXP(ONE_q/FPK(  33554432.)), FPK(2.980232238769530808837006638385259660154e-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*  9*/{FP_EXP(ONE_q/FPK(  16777216.)), FPK(5.960464477539058970696053107082547478976e-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 10*/{FP_EXP(ONE_q/FPK(   8388608.)), FPK(1.192092895507809676556842485667542615950e-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 11*/{FP_EXP(ONE_q/FPK(   4194304.)), FPK(2.384185791015602412454739885388489176212e-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 12*/{FP_EXP(ONE_q/FPK(   2097152.)), FPK(4.768371582031069299637919084648657365212e-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 13*/{FP_EXP(ONE_q/FPK(   1048576.)), FPK(9.536743164061054397103352726493065498015e-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 14*/{FP_EXP(ONE_q/FPK(    524288.)), FPK(1.907348632811343517682682338966633442597e-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 15*/{FP_EXP(ONE_q/FPK(    262144.)), FPK(3.814697265615748141461463760442860953067e-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 16*/{FP_EXP(ONE_q/FPK(    131072.)), FPK(7.629394531175985131691871642256276607879e-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 17*/{FP_EXP(ONE_q/FPK(     65536.)), FPK(1.525878906190788105354014301687863346141e-5), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 18*/{FP_EXP(ONE_q/FPK(     32768.)), FPK(3.051757812026304842848658025753508767879e-5), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 19*/{FP_EXP(ONE_q/FPK(     16384.)), FPK(6.103515621210438743318659798003312847125e-5), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 20*/{FP_EXP(ONE_q/FPK(      8192.)), FPK(1.220703121968350996348993732159954855790e-4), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 21*/{FP_EXP(ONE_q/FPK(      4096.)), FPK(2.441406225746808025002058385388959803342e-4), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 22*/{FP_EXP(ONE_q/FPK(      2048.)), FPK(4.882812305974465934739930750683509788481e-4), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 23*/{FP_EXP(ONE_q/FPK(      1024.)), FPK(9.765623447795782989069101681197863668024e-4), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 24*/{FP_EXP(ONE_q/FPK(       512.)), FPK(0.001953123758236804026919053920001591796737), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 25*/{FP_EXP(ONE_q/FPK(       256.)), FPK(0.003906240065900116554657078991917497880870), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 26*/{FP_EXP(ONE_q/FPK(       128.)), FPK(0.007812420527382831047187992457742556842962), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 27*/{FP_EXP(ONE_q/FPK(        64.)), FPK(0.01562436422488337217479080177074618563764), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* 28*/{FP_EXP(ONE_q/FPK(        32.)), FPK(0.03124491398532607873958112125746446462607), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
#elif 10 == FP_RADIX
/*
 * Check 1 / 10**n for n = 26 to 1
 */
/*  3*/{FPK(1E-26), FPK(+9.999999999999999999999999999999999999999E-27), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*  4*/{FPK(1E-25), FPK(+9.999999999999999999999999999999999999999E-26), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*  5*/{FPK(1E-24), FPK(+9.999999999999999999999999999999999999999E-25), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*  6*/{FPK(1E-23), FPK(+9.999999999999999999999999999999999999999E-24), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*  7*/{FPK(1E-22), FPK(+9.999999999999999999999999999999999999999E-23), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*  8*/{FPK(1E-21), FPK(+9.999999999999999999999999999999999999999E-22), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*  9*/{FPK(1E-20), FPK(+9.999999999999999999999999999999999999999E-21), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 10*/{FPK(1E-19), FPK(+9.999999999999999999999999999999999999983E-20), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 11*/{FPK(1E-18), FPK(+9.999999999999999999999999999999999998333E-19), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 12*/{FPK(1E-17), FPK(+9.999999999999999999999999999999999833333E-18), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 13*/{FPK(1E-16), FPK(+9.999999999999999999999999999999983333333E-17), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 14*/{FPK(1E-15), FPK(+9.999999999999999999999999999998333333333E-16), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 15*/{FPK(1E-14), FPK(+9.999999999999999999999999999833333333333E-15), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 16*/{FPK(1E-13), FPK(+9.999999999999999999999999983333333333333E-14), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 17*/{FPK(1E-12), FPK(+9.999999999999999999999998333333333333333E-13), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 18*/{FPK(1E-11), FPK(+9.999999999999999999999833333333333333333E-12), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 19*/{FPK(1E-10), FPK(+9.999999999999999999983333333333333333333E-11), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 20*/{FPK(1E-9), FPK(+9.999999999999999998333333333333333333416E-10), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 21*/{FPK(1E-8), FPK(+9.999999999999999833333333333333334166666E-9), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 22*/{FPK(1E-7), FPK(+9.999999999999983333333333333341666666666E-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 23*/{FPK(1E-6), FPK(+9.999999999998333333333333416666666666664E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 24*/{FPK(1E-5), FPK(+9.999999999833333333334166666666664682539E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 25*/{FPK(0.0001), FPK(+9.999999983333333341666666664682539682815E-5), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 26*/{FPK(0.001), FPK(+0.0009999998333333416666664682539710097001513), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 27*/{FPK(0.01), FPK(+0.009999833334166664682542438269099729038964), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 28*/{FPK(0.1), FPK(+0.09983341664682815230681419841062202698991), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
#else
  #error Contact Tydeman
#endif
/*
 * Check the basic cycle from 0 to 2 pi in 1/16 increments
 */
/* 29*/{FPK(0.0625), FPK(0.06245931784238019858468150667023075336277),ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 30*/{FPK(0.1250), FPK(0.1246747333852276899574427087121084675878), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 31*/{FPK(0.1875), FPK(0.1864032967622698845523799831032052629564), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 32*/{FPK(0.2500), FPK(0.2474039592545229295968487048493891958933), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 33*/{FPK(0.3125), FPK(0.3074385145803808506705029582019821014239), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 34*/{FPK(0.3750), FPK(0.3662725290860475613729093517162641571764), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 35*/{FPK(0.4375), FPK(0.4236762572039380103616839880311024938692), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 36*/{FPK(0.5000), FPK(0.4794255386042030002732879352155713880818), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 37*/{FPK(0.5625), FPK(0.5333026735360201733291311033081614946279), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 38*/{FPK(0.6250), FPK(0.5850972729404621548053993141500804406894), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 39*/{FPK(0.6875), FPK(0.6346070800152692968503099142036714408128), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 40*/{FPK(0.7500), FPK(0.6816387600233341667332419527798939353383), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 41*/{FPK(0.8125), FPK(0.7260086552607125496573145602464748440975), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 42*/{FPK(0.8750), FPK(0.7675435022360270396345754670545398096930), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 43*/{FPK(0.9375), FPK(0.8060811082606929951828850434097069221620), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 44*/{FPK(1.0000), FPK(0.8414709848078965066525023216302989996225), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 45*/{FPK(1.0625), FPK(0.8735749351670711202276858013085754197088), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 46*/{FPK(1.1250), FPK(0.9022675940990951629184161286548291007589), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 47*/{FPK(1.1875), FPK(0.9274369173848676717163839550054739623499), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 48*/{FPK(1.2500), FPK(0.9489846193555862143484908470360492503780), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 49*/{FPK(1.3125), FPK(0.9668265566961802299725281228283219996732), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 50*/{FPK(1.3750), FPK(0.9808930570231556960891984163070599755882), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 51*/{FPK(1.4375), FPK(0.9911291909537616698772211417745962477329), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 52*/{FPK(1.5000), FPK(0.9974949866040544309417233711414873227066), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 53*/{FPK(1.5625), FPK(0.9999655856782488752995911200563761586773), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 54*/{FPK(1.6250), FPK(0.9985313405398315837513404805953908389323), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 55*/{FPK(1.6875), FPK(0.9931978518853749454485852369532393580100), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 56*/{FPK(1.7500), FPK(0.9839859468739368987316629369679855935380), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 57*/{FPK(1.8125), FPK(0.9709315977974505152142660197103030112612), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 58*/{FPK(1.8750), FPK(0.9540857816096938153194370122923903826757), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 59*/{FPK(1.9375), FPK(0.9335142808623761820293584855425485271132), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 60*/{FPK(2.0000), FPK(0.9092974268256816953960198659117448427022), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 61*/{FPK(2.0625), FPK(0.8815297857963781688201853016282395938486), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 62*/{FPK(2.1250), FPK(0.8503197898184520082433217195624340432564), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 63*/{FPK(2.1875), FPK(0.8157893132582969124757007549656854444795), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 64*/{FPK(2.2500), FPK(0.7780731968879212414109666755877573208044), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 65*/{FPK(2.3125), FPK(0.7373187213346189426405561435947222061390), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 66*/{FPK(2.3750), FPK(0.6936850319532718032180837941439419482648), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 67*/{FPK(2.4375), FPK(0.6473425173671443784337744948227128472046), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 68*/{FPK(2.5000), FPK(0.5984721441039564940518547021861622717035), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 69*/{FPK(2.5625), FPK(0.5472647499254652199696762744192652062100), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 70*/{FPK(2.6250), FPK(0.4939202986100891748043558757550707819886), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 71*/{FPK(2.6875), FPK(0.4386470990986330656979032084963402048308), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 72*/{FPK(2.7500), FPK(0.3816609920523316985765613723777803010822), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 73*/{FPK(2.8125), FPK(0.3231845069996868891851335073782605767344), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 74*/{FPK(2.8750), FPK(0.2634459933634208395338794105857191623073), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 75*/{FPK(2.9375), FPK(0.2026787287608671306274425381762671421511), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 76*/{FPK(3.0000), FPK(0.1411200080598672221007448028081102798469), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 77*/{FPK(3.0625), FPK(0.07901021674738968854631654624847602786795),ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 78*/{FPK(3.1250), FPK(0.01659189222934790431990480238921241224180),ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 79*/{FPK(3.1875),-FPK(0.04589122327277969960485114791978211758055),ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 80*/{FPK(3.2500),-FPK(0.1081951345301083770358308425608250010189), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 81*/{FPK(3.3125),-FPK(0.1700765461024943152141055452902287785135), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 82*/{FPK(3.3750),-FPK(0.2312938124020218257383781053585361563686), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 83*/{FPK(3.4375),-FPK(0.2916078813138528918286526058519177656566), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 84*/{FPK(3.5000),-FPK(0.3507832276896198481203688000436355850849), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 85*/{FPK(3.5625),-FPK(0.4085887730680894715181196389791680682111), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 86*/{FPK(3.6250),-FPK(0.4647987880316089720387595963111378281360), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 87*/{FPK(3.6875),-FPK(0.5191937736746512726565422734800445629172), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 88*/{FPK(3.7500),-FPK(0.5715613187423437724341555733502934979185), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 89*/{FPK(3.8125),-FPK(0.6216969290918729810541132184111305174517), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 90*/{FPK(3.8750),-FPK(0.6694048262377359902911982928125407274394), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 91*/{FPK(3.9375),-FPK(0.7144987118625366644565913395436786323672), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 92*/{FPK(4.0000),-FPK(0.7568024953079282513726390945118290941359), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 93*/{FPK(4.0625),-FPK(0.7961509812048658514328401773141580663400), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 94*/{FPK(4.1250),-FPK(0.8323905145579873242791279038748731617928), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 95*/{FPK(4.1875),-FPK(0.8653795807650819305895465909489878185861), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 96*/{FPK(4.2500),-FPK(0.8949893582285835244657528284382762058810), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 97*/{FPK(4.3125),-FPK(0.9211042214011522414996052952699781286397), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 98*/{FPK(4.3750),-FPK(0.9436221923009624513021447777001573870057), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/* 99*/{FPK(4.4375),-FPK(0.9624553387335394375570360554535450324511), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*100*/{FPK(4.5000),-FPK(0.9775301176650970553891350144986297778643), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*101*/{FPK(4.5625),-FPK(0.9887876624065108307536732789269458815943), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*102*/{FPK(4.6250),-FPK(0.9961840124864792326869182927254056484452), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*103*/{FPK(4.6875),-FPK(0.9996902853162233429814049281595005929367), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*104*/{FPK(4.7500),-FPK(0.9992927889753779447342707555970792632477), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*105*/{FPK(4.8125),-FPK(0.9949930756786475387083483794154181884367), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*106*/{FPK(4.8750),-FPK(0.9868079357144411399591659229627380447333), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*107*/{FPK(4.9375),-FPK(0.9747693318791553561326099092532645240624), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*108*/{FPK(5.0000),-FPK(0.9589242746631384688931544061559939733524), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*109*/{FPK(5.0625),-FPK(0.9393346386757316576995600126524643728550), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*110*/{FPK(5.1250),-FPK(0.9160769210262436514086779916237620003206), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*111*/{FPK(5.1875),-FPK(0.8892419426043759309977913640018782771753), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*112*/{FPK(5.2500),-FPK(0.8589344934265920303307256894227081508543), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*113*/{FPK(5.3125),-FPK(0.8252729234333457731902133540376515457426), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*114*/{FPK(5.3750),-FPK(0.7883886803350965132904396478919235353893), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*115*/{FPK(5.4375),-FPK(0.7484257963118127975706029817200198951151), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*116*/{FPK(5.5000),-FPK(0.7055403255703919062319191755220700788472), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*117*/{FPK(5.5625),-FPK(0.6598997349563215098314715254924385542092), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*118*/{FPK(5.6250),-FPK(0.6116822499992318636306733689941834271377), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*119*/{FPK(5.6875),-FPK(0.5610761589460166631245506761119480474229), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*120*/{FPK(5.7500),-FPK(0.5082790774992583299817794092634332954110), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*121*/{FPK(5.8125),-FPK(0.4534971771321384429103810966489233371769), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*122*/{FPK(5.8750),-FPK(0.3969443799932470740026047152968242126662), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*123*/{FPK(5.9375),-FPK(0.3388415235451705209038381357972480132090), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*124*/{FPK(6.0000),-FPK(0.2794154981989258728115554466118947596279), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*125*/{FPK(6.0625),-FPK(0.2188983613117614885299675260648712478235), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*126*/{FPK(6.1250),-FPK(0.1575264310081430150908090998393976288509), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*127*/{FPK(6.1875),-FPK(0.09553936336253460412695427953329935064356),ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*128*/{FPK(6.2500),-FPK(0.03317921654755681687744567078929268733816),ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*
 * Check the basic cycle from 355 to 355 + 2*pi in 1/16 increments
 */
/*129*/{FPK(355.0000), FPK(-3.014435335948844921433028000865009959025e-5), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*130*/{FPK(355.0625), FPK(-0.06248940331083447003579980153739965743851),ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*131*/{FPK(355.1250), FPK(-0.1247046424856662654712959437179856312206), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*132*/{FPK(355.1875), FPK(-0.1864329127002956121719246134944217741416), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*133*/{FPK(355.2500), FPK(-0.2474331663805316058022996259991507930677), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*134*/{FPK(355.3125), FPK(-0.3074671988411704498696150799867118344123), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*135*/{FPK(355.3750), FPK(-0.3663005784701935490497753021582817593989), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*136*/{FPK(355.4375), FPK(-0.4237035621791955588173219101546791419604), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*137*/{FPK(355.5000), FPK(-0.4794519925452280606660465351546784982504), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*138*/{FPK(355.5625), FPK(-0.5333281731407391623819099263905350182332), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*139*/{FPK(355.6250), FPK(-0.5851217186334643414634864151154892460872), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*140*/{FPK(355.6875), FPK(-0.6346303763366466502526151323443774275562), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*141*/{FPK(355.7500), FPK(-0.6816608160014502542118479793030583871428), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*142*/{FPK(355.8125), FPK(-0.7260293847674448301959858879281248128733), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*143*/{FPK(355.8750), FPK(-0.7675628243230953392325252690333172489638), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*144*/{FPK(355.9375), FPK(-0.8060989474757608086250005379316873393037), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*145*/{FPK(356.0000), FPK(-0.8414872714892107568672464332331484806297), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*146*/{FPK(356.0625), FPK(-0.8735896057154898132777317895639759456116), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*147*/{FPK(356.1250), FPK(-0.9022805912264406764527225159266702349910), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*148*/{FPK(356.1875), FPK(-0.9274481903376358626071140217790681751915), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*149*/{FPK(356.2500), FPK(-0.9489941241131377662348737889700753317104), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*150*/{FPK(356.3125), FPK(-0.9668342561426403077408372303477377300556), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*151*/{FPK(356.3750), FPK(-0.9808989210923506428167886553917826871500), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*152*/{FPK(356.4375), FPK(-0.9911331967466267715407337246333780443250), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*153*/{FPK(356.5000), FPK(-0.9974971184780542740808212245511449036736), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*154*/{FPK(356.5625), FPK(-0.9999658353084611130531617503573583907295), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*155*/{FPK(356.6250), FPK(-0.9985297069514555794669995691963266791368), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*156*/{FPK(356.6875), FPK(-0.9931943414575383483078772744874255886978), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*157*/{FPK(356.7500), FPK(-0.9839805733147852867946039608458630718870), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*158*/{FPK(356.8125), FPK(-0.9709243820906173802940529371255997704436), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*159*/{FPK(356.8750), FPK(-0.9540767519323599232508348301318920899390), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*160*/{FPK(356.9375), FPK(-0.9335034724752382847753714560418204780598), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*161*/{FPK(357.0000), FPK(-0.9092848819352602648173786171926253962649), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*162*/{FPK(357.0625), FPK(-0.8815155533902018374606383042656405750551), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*163*/{FPK(357.1250), FPK(-0.8503039254737623183623788760050273952102), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*164*/{FPK(357.1875), FPK(-0.8157718789250203771900999436874609088799), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*165*/{FPK(357.2500), FPK(-0.7780542606467562074016648950628718041588), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*166*/{FPK(357.3125), FPK(-0.7372983571311819200493853464115002810813), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*167*/{FPK(357.3750), FPK(-0.6936633193093414156265037114277360868456), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*168*/{FPK(357.4375), FPK(-0.6473195410701305191196186906220217795972), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*169*/{FPK(357.5000), FPK(-0.5984479938758073048234656303369349522321), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*170*/{FPK(357.5625), FPK(-0.5472395200723048037396257320391626352966), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*171*/{FPK(357.6250), FPK(-0.4938940876539541991373280474914718162442), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*172*/{FPK(357.6875), FPK(-0.4386200093927463180149761078053594948470), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*173*/{FPK(357.7500), FPK(-0.3816331293814149415495917512077536438116), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*174*/{FPK(357.8125), FPK(-0.3231559801668737860675460089595204038209), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*175*/{FPK(357.8750), FPK(-0.2634169137653830456142979209019647111394), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*176*/{FPK(357.9375), FPK(-0.2026492099528126743266514106153492453636), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*177*/{FPK(358.0000), FPK(-0.1410901653121098477246754173850575855254), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*178*/{FPK(358.0625), FPK(-0.07898016659522074792210479382894627207433),ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*179*/{FPK(358.1250), FPK(-0.01656175201796853794534991037753150616363),ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*180*/{FPK(358.1875), FPK(+0.04592133584648906180435664815640360966600),ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*181*/{FPK(358.2500), FPK(+0.1082251018771918150495793686260926991347), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*182*/{FPK(358.3125), FPK(+0.1701062512011027753867417854917310177801), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*183*/{FPK(358.3750), FPK(+0.2313231392543809370336480867010736665502), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*184*/{FPK(358.4375), FPK(+0.2916367153992317923729264526055144408912), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*185*/{FPK(358.5000), FPK(+0.3508114564115321884519074379293019264231), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*186*/{FPK(358.5625), FPK(+0.4086162861939802841945872076556709236695), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*187*/{FPK(358.6250), FPK(+0.4648254781233104397865504333744190436715), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*188*/{FPK(358.6875), FPK(+0.5192195365079264744991381455594019333820), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*189*/{FPK(358.7500), FPK(+0.5715860537138800984492012816758610418235), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*190*/{FPK(358.8125), FPK(+0.6217205396121359151843239809080124321739), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*191*/{FPK(358.8750), FPK(+0.6694272201081491755943711641630406842345), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*192*/{FPK(358.9375), FPK(+0.7145198016355153707116475655010060993712), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*193*/{FPK(359.0000), FPK(+0.7568221986283603220554834062118202814836), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*194*/{FPK(359.0625), FPK(+0.7961692211317066542718562757437950643943), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*195*/{FPK(359.1250), FPK(+0.8324072198647128839905866385596279893126), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*196*/{FPK(359.1875), FPK(+0.8653946862178269807393516840933597796899), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*197*/{FPK(359.2500), FPK(+0.8950028048408783553172134918784568993920), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*198*/{FPK(359.3125), FPK(+0.9211159566642636019078092462406429158974), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*199*/{FPK(359.3750), FPK(+0.9436321703889390283623751037591896045446), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*200*/{FPK(359.4375), FPK(+0.9624635206821612157972187855505192278029), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*201*/{FPK(359.5000), FPK(+0.9775364715240297620882226606662254081966), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*202*/{FPK(359.5625), FPK(+0.9887921633640713075331313627925706581446), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*203*/{FPK(359.6250), FPK(+0.9961866429665245272692537948958890121052), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*204*/{FPK(359.6875), FPK(+0.9996910350467851712858653835518848180921), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*205*/{FPK(359.7500), FPK(+0.9992916550287745072040213887593652590098), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*206*/{FPK(359.8125), FPK(+0.9949900624829160550847704766689937171387), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*207*/{FPK(359.8750), FPK(+0.9868030550360464586996413174564628444841), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*208*/{FPK(359.9375), FPK(+0.9747626027770421609819759431856772851327), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*209*/{FPK(360.0000), FPK(+0.9589157234143065077588759477537844006739), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*210*/{FPK(360.0625), FPK(+0.9393242986726246209691561207304217014443), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*211*/{FPK(360.1250), FPK(+0.9160648326463523939436753248843485132548), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*212*/{FPK(360.1875), FPK(+0.8892281530525652344318010400969047053590), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*213*/{FPK(360.2500), FPK(+0.8589190565507666162906310503346882091703), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*214*/{FPK(360.3125), FPK(+0.8252558995141753877140560291969486544036), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*215*/{FPK(360.3750), FPK(+0.7883701358506212014874271791354576587814), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*216*/{FPK(360.4375), FPK(+0.7484058036778475798881968794399826461095), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*217*/{FPK(360.5000), FPK(+0.7055189628577445705137890217000256162185), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*218*/{FPK(360.5625), FPK(+0.6598770855859277776367334873836131622543), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*219*/{FPK(360.6250), FPK(+0.6116584024163984214657686018262629061228), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*220*/{FPK(360.6875), FPK(+0.5610512062750441325795394006316301202308), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*221*/{FPK(360.7500), FPK(+0.5082531171797928666815315086645667406736), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*222*/{FPK(360.8125), FPK(+0.4534703105386720035046109399472490823131), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*223*/{FPK(360.8750), FPK(+0.3969167120392521945093843819366389339208), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*224*/{FPK(360.9375), FPK(+0.3388131622734154516255633791178831132386), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*225*/{FPK(361.0000), FPK(+0.2793865543595698804541801960820554996777), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*226*/{FPK(361.0625), FPK(+0.2188689479298778543418871195151169280804), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*227*/{FPK(361.1250), FPK(+0.1574966629423585424585663069728096481638), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*228*/{FPK(361.1875), FPK(+0.09550935685650913890540482578083404299500),ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*229*/{FPK(361.2500), FPK(+0.03314908877605424332906675892471435580053),ULP_f, IMPL_INEXACT_sin, FE_INEXACT},

#if 2 == FP_RADIX
/*
 * Check 2**n for n = 10 to 125 by 5
 * The purpose of these numbers is to find where argument reduction falls apart.
 */
/*230*/{FPK(1024.), FPK(-1.585333800439959600437986798069007707858E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*231*/{FPK(32768.), FPK(0.9278563334139246745713847199034359488816), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*232*/{FPK(1.048576E6), FPK(0.3304931400217346716397309590712820880787), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*233*/{FPK(3.3554432E7), FPK(-9.765172909509284848344261368493310111408E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*234*/{FPK(1.073741824E9), FPK(-6.173264150460421707542163571696069369354E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*235*/{FPK(3.4359738368E10), FPK(-6.444303510232911324935356442109536997682E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*236*/{FPK(1.099511627776E12), FPK(-4.057050115328287198206483025752853128929E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*237*/{FPK(3.5184372088832E13), FPK(0.7184912917209150969941690944271950686993), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*238*/{FPK(1.125899906842624E15), FPK(0.4963965152089408408768218598654113680933), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*239*/{FPK(3.6028797018963968E16), FPK(-7.920784407908279816464686391409708666904E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*240*/{FPK(1.152921504606846976E18), FPK(-8.306492176372546505752817955815103010761E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*241*/{FPK(3.6893488147419103232E19), FPK(-4.718387621235467380510614980570001394321E-2), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*242*/{FPK(1.180591620717411303424E21), FPK(-9.981794021933067599641604936283969880501E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*243*/{FPK(3.7778931862957161709568E22), FPK(0.9357378532015472984524543646583468412467), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*244*/{FPK(1.208925819614629174706176E24), FPK(-8.582954304350270627359027658209681538177E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*245*/{FPK(3.8685626227668133590597632E25), FPK(-9.993765291704066514261216744242424137273E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*246*/{FPK(1.237940039285380274899124224E27), FPK(-9.044312486086015809361973879526097147471E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*247*/{FPK(3.9614081257132168796771975168E28), FPK(0.9994517810498042798234031591722028856604), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*248*/{FPK(1.267650600228229401496703205376E30), FPK(-8.721836054182673097807197782134705593243E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*249*/{FPK(4.0564819207303340847894502572032E31), FPK(-6.042037178234905391689428317467214508694E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*250*/{FPK(1.298074214633706907132624082305024E33), FPK(0.9426995022783539524300073696307047770023), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*251*/{FPK(4.1538374868278621028243970633760768E34), FPK(-9.939250685744649681265948312561340905991E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*252*/{FPK(1.329227995784915872903807060280344576E36), FPK(0.3778201093607520226555484700569229919605), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*253*/{FPK(4.2535295865117307932921825928971026432E37), FPK(0.1674733484996188250831220226309338575950), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
#elif 10 == FP_RADIX
/*
 * Check 10**n for n = 3 to 36 by 1.5
 * The purpose of these numbers is to find where argument reduction falls apart.
 */
/*230*/{FPK(1E03), FPK(+0.8268795405320025602558874291092181412127), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*231*/{FPK(3E04), FPK(-8.026654418673739681773790688205777419834E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*232*/{FPK(1E06), FPK(-3.499935021712929521176524867807714690614E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*233*/{FPK(3E07), FPK(+0.9641302978985831816963488807893200392551), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*234*/{FPK(1E09), FPK(+0.5458434494486995642443872708975145289950), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*235*/{FPK(3E10), FPK(-9.990712047537218211571486309462010373282E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*236*/{FPK(1E12), FPK(-6.112387023768894981920204153246305664962E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*237*/{FPK(3E13), FPK(-7.702205263277148315410094946272690046040E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*238*/{FPK(1E15), FPK(+0.8582727931702358355238863908484066466002), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*239*/{FPK(3E16), FPK(+0.4431329102049319611370816095263311342036), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*240*/{FPK(1E18), FPK(-9.929693207404050762095530172636302708599E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*241*/{FPK(3E19), FPK(+0.4058538432483056906317807546827240842920), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*242*/{FPK(1E21), FPK(-6.671201770718048469651957581261762486894E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*243*/{FPK(3E22), FPK(-8.097173303374905258557168232907550310191E-2), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*244*/{FPK(1E24), FPK(-9.964722291025832583758359242621848977258E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*245*/{FPK(3E25), FPK(-5.817943218542861418020664158142186363847E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*246*/{FPK(1E27), FPK(+0.7180634961391176660795156521463470527234), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*247*/{FPK(3E28), FPK(+0.8922322915475959930327161155654418149847), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*248*/{FPK(1E30), FPK(-9.011690191213805803038642895298733027439E-2), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*249*/{FPK(3E31), FPK(+0.4208779386124015001361663807422689761529), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*250*/{FPK(1E33), FPK(+0.7623023949526979198881641510882361927460), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*251*/{FPK(3E34), FPK(-7.663566361591860764006147696108048303826E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*252*/{FPK(1E36), FPK(+0.2148286106567870594481053381884183324835), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*253*/{FPK(3E37), FPK(+0.2107135949004885089764108332531504695708), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
#else
  #error Contact Tydeman
#endif

#if 2 == FP_RADIX
/*
 * The following are 21-bit (so as to work on S/360 and IEEE-754 single)
 * values in each binade that is the closest to a multiple of pi.
 * Not all binades are represented as the continued fraction theory did
 * not find a value in all cases.  The purpose of these numbers is to find
 * where argument reduction falls apart.
 */
/*254*/{FPK(3.1415920257568359375), FPK(+6.278329573009213974553358977675337971483E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*255*/{FPK(6.283184051513671875), FPK(-1.255665914601595319343010184344785243721E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*256*/{FPK(15.7079620361328125), FPK(+1.231816153692001696557413829217671299099E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*257*/{FPK(53.407073974609375), FPK(+1.136417110053620334368157007676774196529E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*258*/{FPK(128.8052978515625), FPK(+9.456190227768274506944554934061255099156E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*259*/{FPK(430.398193359375), FPK(+1.824266736693811316648097152430664554061E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*260*/{FPK(860.79638671875), FPK(-3.648533473387561922627263511748668004920E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*261*/{FPK(1721.5927734375), FPK(-7.297066946774638159903080690718568242850E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*262*/{FPK(4476.76953125), FPK(+1.154553648092665646710863710518580157606E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*263*/{FPK(8953.5390625), FPK(-2.309107296185315903289413085331687526233E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*264*/{FPK(17907.078125), FPK(-4.618214592370508685520311486250490099338E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*265*/{FPK(35814.15625), FPK(-9.236429184740032402572505536586616052104E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*266*/{FPK(78172.25), FPK(-7.251748473339811348721483298894342225232E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*267*/{FPK(9.900635E5), FPK(+8.625697217865673479267250982332791202198E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*268*/{FPK(1.146408E6), FPK(-5.877799728813812324370607306023798567022E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*269*/{FPK(4.4501216E7), FPK(-8.933837734484691269226927462791740678551E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*270*/{FPK(1.28918016E8), FPK(-3.290314288200976547805246487670803148933E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*271*/{FPK(5.347127296E9), FPK(-1.170336779367194171640036202744013365384E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*272*/{FPK(1.501003776E10), FPK(-8.787589075414421807802983011654755151615E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*273*/{FPK(2.29656756224E11), FPK(+2.714514115067171987106105538573563081901E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*274*/{FPK(2.586264469504E12), FPK(-5.290701035922705794410766260238399373520E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*275*/{FPK(5.172528939008E12), FPK(+1.058140207184393064131775470224119397548E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*276*/{FPK(9.596047458304E12), FPK(+5.844009812768452089544319546853551675522E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*277*/{FPK(1.07054542880768E14), FPK(+1.027048002753363606516265082348880097144E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*278*/{FPK(6.34229230665728E14), FPK(+1.765242439522665652167802776065586461206E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*279*/{FPK(3.05653787161264128E17), FPK(-2.656315332700862512162846211619076730969E-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*280*/{FPK(5.595493838589263872E19), FPK(+7.877187476298989913992886367651256258215E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*281*/{FPK(7.5516780764213542912E19), FPK(-9.123230652984451934652449086975659415087E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*282*/{FPK(4.50370095836211183616E20), FPK(+4.139057946241947419026043875649594515295E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*283*/{FPK(8.260425875329298464768E21), FPK(-2.621860137770594971547866036312503028136E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*284*/{FPK(1.6520851750658596929536E22), FPK(+5.243720275541009712481811487992309813642E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*285*/{FPK(3.3041703501317193859072E22), FPK(+1.048744055108057758005225837325899246115E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*286*/{FPK(1.62352532781291205033984E23), FPK(-1.466472627370879658032042202858183081703E-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*287*/{FPK(3.24705065562582410067968E23), FPK(+2.932945254741759000692991569149261799913E-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*288*/{FPK(6.49410131125164820135936E23), FPK(+5.865890509483515478417240445762095623145E-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*289*/{FPK(1.298820262250329640271872E24), FPK(+1.173178101896701077308453935124578923322E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*290*/{FPK(2.597640524500659280543744E24), FPK(+2.346356203793386007616954638068105997439E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*291*/{FPK(5.195281049001318561087488E24), FPK(+4.692712407586642839234283420021229561081E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*292*/{FPK(1.0390562098002637122174976E25), FPK(+9.385424815172252270471560033792435167028E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*293*/{FPK(2.745770185255556193714176E25), FPK(+3.085355891827358732078515092717037462459E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*294*/{FPK(5.491540370511112387428352E25), FPK(-6.170711783654423756140979538867120939543E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*295*/{FPK(1.0983080741022224774856704E26), FPK(-1.234142356730649784815355407295442498178E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*296*/{FPK(2.67900440869005331678625792E26), FPK(+8.997353396098194926688314534296615493869E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*297*/{FPK(2.068258390277280666476347392E27), FPK(+2.394988186164515142572617962148471011612E-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*298*/{FPK(4.136516780554561332952694784E27), FPK(-4.789976372329028911387577660724338388481E-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*299*/{FPK(8.273033561109122665905389568E27), FPK(-9.579952744658046832713889212872575597330E-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*300*/{FPK(1.6546067122218245331810779136E28), FPK(-1.915990548931600574493764955728763450384E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*301*/{FPK(3.3092134244436490663621558272E28), FPK(-3.831981097863130812595426817175650336084E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*302*/{FPK(6.6184268488872981327243116544E28), FPK(-7.663962195725698934054028895588665369724E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*303*/{FPK(1.71129645511276284654179581952E29), FPK(+1.883695152966648733577166175930225852650E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*304*/{FPK(3.42259291022552569308359163904E29), FPK(-3.767390305933230627859274082431931327829E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*305*/{FPK(6.84518582045105138616718327808E29), FPK(-7.534780611865926541358082023665681669382E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*306*/{FPK(1.617689026668547205887002935296E30), FPK(-9.935202100270903670354338363939506344677E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*307*/{FPK(2.986726190758757483120439590912E30), FPK(+5.134359123460515256545708376976777260830E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*308*/{FPK(5.973452381517514966240879181824E30), FPK(-1.026871824691967701163770116970922510442E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*309*/{FPK(1.2195556625613366861135324643328E31), FPK(-4.467326830162705183945194313657012272618E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*310*/{FPK(2.4391113251226733722270649286656E31), FPK(+8.934653660324518823072498924424096835812E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*311*/{FPK(7.2924687891101864238158381580288E31), FPK(-1.799197656971295806247733208735072352102E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*312*/{FPK(1.45849375782203728476316763160576E32), FPK(+3.598395313942533370448451238036120064124E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*313*/{FPK(2.91698751564407456952633526321152E32), FPK(+7.196790627884600804520781051912205495275E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*314*/{FPK(2.114318645116797389049285933268992E33), FPK(-2.167205404156208649135525584320909846793E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*315*/{FPK(4.228637290233594778098571866537984E33), FPK(+4.334410808312315509417024721661629638514E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*316*/{FPK(8.457274580467189556197143733075968E33), FPK(+8.668821616623816708001837896166525569122E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*317*/{FPK(1.54319129417236934308375027515392E34), FPK(+2.576200242496167271575375278449887188754E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*318*/{FPK(3.08638258834473868616750055030784E34), FPK(-5.152400484992163565694961265779457567511E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*319*/{FPK(6.3210287986105459404906795720769536E34), FPK(-9.609042505759738877389520758168420590255E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*320*/{FPK(5.6296204699810639191793402262847488E35), FPK(-6.826008648866425665861420367158377375486E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*321*/{FPK(1.562465565022108256943988476443885568E36), FPK(-1.259940935078428716573360590142196301582E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
/*322*/{FPK(2.52291757244885323909936117700681007104E38), FPK(+4.624949951738393474920392501416480223447E-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
#elif 10 == FP_RADIX
{FPK(3.141592), FPK(+6.535897932384161100102644619365339705825E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(6.283184), FPK(-1.307179586476553019782438702040818949098E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(15.70796), FPK(+3.267948966186496545289520377679361098631E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(53.40707), FPK(+5.111026485031612727816615319657984476046E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(128.8053), FPK(-1.202818477222741587211919929509221923684E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(430.3982), FPK(-6.458198326285724416702889892152755660629E-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(860.7964), FPK(+1.291639665230208819468111742427807825761E-5), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1721.593), FPK(+0.0002258327913857267757392146358474999320355), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(4476.77), FPK(-4.686345274817344074943853680167514706662E-4), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(8953.539), FPK(-6.273091068847576367031335487681137421225E-5), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.790708E4), FPK(+0.001874537080719738915146997746085177522670), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(3.581416E4), FPK(+0.003749067574517962874999150763391004345071), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(7.817225E4), FPK(-7.251748473339811348721483298894342225232E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(9.900635E5), FPK(+8.625697217865673479267250982332791202198E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.146408E6), FPK(-5.877799728813812324370607306023798567022E-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(4.450122E7), FPK(+0.7568030792622307339109334215438814178505), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.28918E8), FPK(-2.879030015649825764204762275456040467971E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(5.347127E9), FPK(+0.6367603481630346278831269988889143362638), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.501004E10), FPK(+0.04442424427030313290836077149153767661948), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(2.296568E11), FPK(-8.664086775587567817634034882270333093800E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(2.586264E12), FPK(-6.734709131945192223478651247902844293813E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(5.172529E12), FPK(+0.9001981282537585242412281125570632546459), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(9.596047E12), FPK(+0.8198122416414417888100322101132819257539), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.070545E14), FPK(+0.9315624356102124679733135476862526461017), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(6.342292E14), FPK(+0.9402653421972763697288248723255309348941), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(3.056538E17), FPK(-4.819477158376757396722984613364383538141E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(5.595494E19), FPK(+0.9902392507603945004999663721521681606291), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(7.551678E19), FPK(+0.9760180776832362057777807219476883382399), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(4.503701E20), FPK(-9.951028434384447188235491596877938531070E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(8.260426E21), FPK(+0.1092967599303226634061697418672854964781), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.652085E22), FPK(+0.7570411203580101448216336310165170181244), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(3.30417E22), FPK(-9.892517252274908802764556657945756613400E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.623525E23), FPK(-9.533459967662905251064436009707674762374E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(3.247051E23), FPK(-1.298559880540178005179367978861272579008E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(6.494101E23), FPK(+0.6769062435566063983106639803336446413662), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.29882E24), FPK(-6.352112746890915728639380179287774522608E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(2.597641E24), FPK(-7.551011803263719212390934172171914548635E-2), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(5.195281E24), FPK(+0.9638204106858399531540154096166369382258), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.039056E25), FPK(-7.010928746522729487018084306790044170425E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(2.74577E25), FPK(-9.678816457225126853685762818665880912743E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(5.49154E25), FPK(+0.4866630567251202777923655703833563426659), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.098308E26), FPK(-8.502877260970179990360753011578672101201E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(2.679004E26), FPK(-9.976116616261606946588366986598361231943E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(2.068258E27), FPK(-8.617312904516009830216089868240577505197E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(4.136517E27), FPK(+0.9750637369779015799803931368949854657530), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(8.273034E27), FPK(+0.4327820537423621206715563274282174538592), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.654607E28), FPK(-7.073675757379736186462174184969720632181E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(3.309213E28), FPK(+0.5225859110194661177761957268770250372509), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(6.618427E28), FPK(-8.529719507924156367469625879489594732765E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.711296E29), FPK(+0.4084554122642838816198779807393075019397), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(3.422593E29), FPK(+0.9988615160671294616584441298693464863618), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(6.845186E29), FPK(+0.09529938170414580702492983516031246990642), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.617689E30), FPK(+0.9064634356121920825441663654328764679124), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(2.986726E30), FPK(-2.262937371753417839356050040644165172365E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(5.973452E30), FPK(+0.4408469512414543559063915866575939824408), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.219556E31), FPK(+0.9485941236614207026910532148285664583459), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(2.439111E31), FPK(-1.948995143458218542078338559977343388595E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(7.292469E31), FPK(-2.219928918078699722128403276017714381103E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.458494E32), FPK(+0.9433957481766952489915170423170398639990), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(2.916988E32), FPK(+0.6257906378058135677732601267059986135440), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(2.114319E33), FPK(+0.9374767729666817312811508966641102186975), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(4.228637E33), FPK(+0.08991838884359743754762386744974330571829), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(8.457275E33), FPK(+0.5817966018846001520278263175440042150021), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.543191E34), FPK(+0.6307347425467390832056455284613599960176), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(3.086383E34), FPK(-3.541211939790706912024009008504124089909E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(6.321029E34), FPK(-7.964165062932044477553968141046984458035E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(5.62962E35), FPK(+0.9827045455749562780505060498963986581618), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(1.562466E36), FPK(+0.9310064462766659946793257180900602715517), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
{FPK(2.522918E38), FPK(-1.594500815566587245382263522615370829365E-1), ULP_f, IMPL_INEXACT_sin, FE_INEXACT },
#else
  #error Contact Tydeman
#endif

/*
 * Take the value pi.  Convert it to a continued fraction.  Take the first n
 * terms of the continued fraction and convert that to a fraction.  Take
 * the numerator of that fraction.  That is the n-th element of the following
 * integer arguments. Compute the sine() of those arguments; it will get
 * closer and closer to 0.  The following was done using DeriveXM.
 *
 * Some sample fractions that result from the continued fraction are:
 * 22/7, 355/113, ...  These numbers are special in that 355 is about 113 * pi,
 * so, 355 is very close to multiple of pi, so is a good number to test
 * argument reduction which is the limiting factor on accuracy of sine.
 */
/*323*/{FPK(3.), FPK(0.1411200080598672221007448028081102798469), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*324*/{FPK(22.), FPK(-0.008851309290403875921690256815772332463289), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*325*/{FPK(333.), FPK(-0.008821166113885877006219004546656019816162), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*326*/{FPK(355.), FPK(-3.014435335948844921433028000865009959025e-5), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*327*/{FPK(1.03993e5), FPK(-1.912933577842375022430719872695874427491e-5), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*328*/{FPK(1.04348e5), FPK(-1.101501758424055688621168230459696452484e-5), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*329*/{FPK(2.08341e5), FPK(8.114318195038077209773327760926281832092e-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*330*/{FPK(3.12689e5), FPK(2.900699389332111000449710765980492315487e-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*331*/{FPK(8.33719e5), FPK(2.312919416452701500600480039068230636020e-6), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*332*/{FPK(1.146408e6), FPK(-5.877799728813812324370607306023798567022e-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* #if PREC_q >= 23 */
/*333*/{FPK(4.272943e6), FPK(-5.495794978104908005031386643096134921349e-7), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*334*/{FPK(5.419351e6), FPK(-3.820047507089660191845987249928614346965e-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
#if ((2==FP_RADIX)&&(PREC_q >= 27)) || ((10==FP_RADIX)&&(7<PREC_q))
/*335*/{FPK(8.0143857e7), FPK(-1.477284681796590864991624557530997292064e-8), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*336*/{FPK(1.65707065e8), FPK(-8.654781434964792726759985393635564874554e-9), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*337*/{FPK(2.45850922e8), FPK(6.118065383001116314271210985987376942726e-9), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*338*/{FPK(4.11557987e8), FPK(2.536716051963676479648989773970813487609e-9), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*339*/{FPK(1.068966896e9), FPK(1.044633279073763387509311412084278779982e-9), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*340*/{FPK(2.549491779e9), FPK(4.474494938161497069560455111766419779553e-10), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*341*/{FPK(6.167950454e9), FPK(1.497342914414639737567936196228910303780e-10), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*342*/{FPK(1.4885392687e10), FPK(1.479809109332217594557298722864333901077e-10), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*343*/{FPK(2.1053343141e10), FPK(1.753380508242214301083172878538645332641e-12), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*344*/{FPK(1.783366216531e12), FPK(6.969482408757581652833645960277770161352e-13), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*345*/{FPK(3.587785776203e12), FPK(3.594840264906979705164444643115730410274e-13), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*346*/{FPK(5.371151992734e12), FPK(-3.374642143850601947669201739906430603344e-13), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*347*/{FPK(8.958937768937e12), FPK(-2.201981210563777574952429165657465404519e-14), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*348*/{FPK(1.39755218526789e14), FPK(-7.167032800493558524055805520458585525531e-15), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*349*/{FPK(4.28224593349304e14), FPK(5.187137041571001773568750967942675321726e-16), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* #if PREC_q >= 53 */
/*350*/{FPK(5.706674932067741e15), FPK(4.237546464512562184164292621941499265244e-16), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*351*/{FPK(6.134899525417045e15), FPK(9.495905770584395894044583460012804199730e-17), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
  #if ((2==FP_RADIX)&&(PREC_q >= 55)) || ((10==FP_RADIX)&&(16<PREC_q))
/*352*/{FPK(3.0246273033735921e16), FPK(4.391841562788038265464592379364985570114e-17), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*353*/{FPK(6.6627445592888887e16), FPK(7.122226450083193631153987012828445008960e-18), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*354*/{FPK(4.30010946591069243e17), FPK(1.185056927381220867722001716679199404323e-18), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* #if PREC_q >= 62 */
/*355*/{FPK(2.646693125139304345e18), FPK(1.188488579586842482197671275324864157187e-20), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
    #if ((2==FP_RADIX)&&(PREC_q >= 68)) || ((10==FP_RADIX)&&(20<PREC_q))
/*356*/{FPK(2.62452630335382199398e20), FPK(-8.453233590246810346307154107583888984839e-21), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*357*/{FPK(2.65099323460521503743e20), FPK(-3.431652205621614475669558645664752587034e-21), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*358*/{FPK(7.92651277256425206884e20), FPK(-1.589929179003581394968036816254383810770e-21), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*359*/{FPK(1.850401877973371917511e21), FPK(-2.517938476144516857334850131559849654948e-22), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*360*/{FPK(1.189506254509665671195e22), FPK(-7.916609331687128056712673731847401780091e-23), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*361*/{FPK(3.7535589513263342053361e22), FPK(1.429556766383784403210480120056291209211e-23), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*362*/{FPK(1.99573010111413366978755e23), FPK(7.688254997682060406602731315659457340328e-24), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*363*/{FPK(2.37108599624676709032116e23), FPK(6.607312666155783625502069884903454751788e-24), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*364*/{FPK(4.36681609736090076010871e23), FPK(-1.080942331526276781100661430756002588539e-24), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*365*/{FPK(2.857198258041217165097342e24), FPK(1.216586769981229388981013003674392205500e-25), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*366*/{FPK(2.3294267674065827396789607e25), FPK(-1.076729155412932699158510278164888241393e-25), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*367*/{FPK(2.6151465932107044561886949e25), FPK(-1.398576145682966898225027255095039641073e-26), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*368*/{FPK(2.06354529198815139329998250e26), FPK(-9.772585343485587040099119959836049264156e-27), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*369*/{FPK(2.32505995130922183891885199e26), FPK(4.213176113344081942151152591114347146581e-27), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*370*/{FPK(6.71366519460659507113768648e26), FPK(-1.346233116797423155796814777607354970993e-27), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*371*/{FPK(2.246605553512900705233191143e27), FPK(-1.744767629518124747607082582922822335990e-28), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*372*/{FPK(1.6397605394050964443746106649e28), FPK(-1.248957761347358324718569695613793358004e-28), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*373*/{FPK(1.8644210947563865148979297792e28), FPK(4.958098681707664228885128873090289779862e-29), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*374*/{FPK(5.3686027289178694741704702233e28), FPK(-2.573380250058254789415439209957354020320e-29), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*375*/{FPK(7.2330238236742559890684000025e28), FPK(-2.384718431649409439469689663132935759542e-29), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*376*/{FPK(1.26016265525921254632388702258e29), FPK(-1.886618184088453499457495468244182607775e-30), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*377*/{FPK(1.584525424547797615479348427121e30), FPK(-1.207766107432652401206951012399166302112e-30), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*378*/{FPK(1.710541690073718870111737129379e30), FPK(-6.788520766558010982505444558450163056633e-31), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*379*/{FPK(3.295067114621516485591085556500e30), FPK(5.289140307768513029564065565541499964493e-31), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*380*/{FPK(5.005608804695235355702822685879e30), FPK(1.499380458789497952941378992908663092139e-31), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*381*/{FPK(1.8311893528707222552699553614137e31), FPK(7.909989314000191707399285868155106880757e-32), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*382*/{FPK(2.3317502333402457908402376300016e31), FPK(-7.083815273894787822014504060931524040635e-32), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* #if PREC_q >= 106 */
/*383*/{FPK(4.1629395862109680461101929914153e31), FPK(-8.261740401054038853847818072235828401223e-33), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
      #if ((2==FP_RADIX)&&(PREC_q >= 109)) || ((10==FP_RADIX)&&(32<PREC_q))
/*384*/{FPK(3.56352669230279901597217815613240e32), FPK(-4.744229530515567389362496031428613196565e-33), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*385*/{FPK(3.97982065092389582058319745527393e32), FPK(3.517510870538471464485322040807215204657e-33), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*386*/{FPK(7.54334734322669483655537561140633e32), FPK(1.226718659977095924877173990621397991907e-33), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*387*/{FPK(1.906651533737728549369394867808659e33), FPK(1.064073550584279614730974059564419220842e-33), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* #if PREC_q >= 112 */
/*388*/{FPK(2.660986268060398033024932428949292e33), FPK(-1.626451093928163101461999310569787710653e-34), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
        #if ((2==FP_RADIX)&&(PREC_q >= 114)) || ((10==FP_RADIX)&&(34<PREC_q))
/*389*/{FPK(1.7872569142100116747518989441504411e34), FPK(8.820289422738175385377447322254659445057e-35), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*390*/{FPK(2.0533555410160514780543921870453703e34), FPK(7.444221516543455629242545783443217661473e-35), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* #if PREC_q >= 115 */
/*391*/{FPK(3.8406124552260631528062911311958114e34), FPK(1.376067906194719756134901538811441783583e-35), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*392*/{FPK(2.12564178171463672420858478430244273e35), FPK(-5.638819855698568485680380893860087435569e-36), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*393*/{FPK(4.63534480895187976369779868172446660e35), FPK(2.483039350550060589988253600394242964695e-36), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*394*/{FPK(1.139633139961839625160418214775137593e36), FPK(-6.727411545984473057038736930716015061784e-37), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*395*/{FPK(3.882433900780706851851034512497859439e36), FPK(-4.648158867547186728766325211794384461599e-37), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*396*/{FPK(5.022067040742546477011452727272997032e36), FPK(-2.079252678437286328272411718921630600184e-37), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*397*/{FPK(1.3926567982265799805873939967043853503e37), FPK(-4.896535106726140722215017739511232612304e-38), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*398*/{FPK(6.0728338969805745700507212595448411044e37), FPK(-1.206386357468300393864046231171375552627e-38), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*399*/{FPK(2.56839923861488782607902790348837497679e38), FPK(-7.098967685293914675883281482573040179481e-40), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/* #if PREC_q >= 132 */
/*400*/{FPK(4.170167120753626267426951858176848373908e39), FPK(-7.055152782127404572272119395968912391041e-40), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
/*401*/{FPK(4.427007044615115050034854648525685871587e39), FPK(4.381490316651010361116208660412778844028e-42), ULP_f, IMPL_INEXACT_sin, FE_INEXACT},
          #if ((2==FP_RADIX)&&(PREC_q >= 140)) || ((10==FP_RADIX)&&(40<PREC_q))
            #error Need to increase pi reduction tests
          #endif /* 140 */
/* #endif // 132 */
/* #endif // 115 */
        #endif /* 114 */
/* #endif // 112 */
      #endif /* 109 */
/* #endif // 106 */
    #endif /*  68 */
/* #endif //  62 */
  #endif /*  55 */
/* #endif //  53 */
#endif /*  27 */
/* #endif //  23 */
